unit unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, LResources, Forms, Controls, Graphics, Dialogs,
  ExtCtrls, OpenGLContext, dglOpenGL, LCLType, StdCtrls, Math;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    OpenGLControl1: TOpenGLControl;
    Panel1: TPanel;
    Timer1: TTimer;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure OpenGLControl1Paint(Sender: TObject);
    procedure OpenGLControl1Resize(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);


  public
    qaudricParam: PGLUQuadric;
    speed, winkel: single;
    procedure Rad(d: single; speichen: integer; startwinkel: single);
    procedure Pleuel(d, l: single);
  end;

var
  Form1: TForm1;

implementation


{ TForm1 }

procedure TForm1.Rad(d: single; speichen: integer; startwinkel: single);
var
  i: integer;
  l: single;
begin
  glPushMatrix;
  gluQuadricDrawStyle(qaudricParam, GLU_FILL);
  l := d / 20;
  glRotatef(startwinkel, 0, 0, 1);

  for i := 0 to speichen - 1 do begin
    glRotatef(360 / speichen, 0, 0, 1);

    glBegin(GL_QUADS);
    glColor3f(1, 0.5, 0.5);
    glVertex3f(-l, 0, 0);
    glVertex3f(l, 0, 0);
    glVertex3f(l, d - l, 0);
    glVertex3f(-l, d - l, 0);
    glEnd();
  end;

  glTranslatef(0, 0, -0.1); // Nabe/Spurkranz vor Speichen
  glColor3f(1.0, 0.0, 0.0);
  gluDisk(qaudricParam, d / 1.15, d, 36, 1);
  gluDisk(qaudricParam, 0.0, d / 6, 36, 1);
  glColor3f(0.7, 0.7, 0.7);
  gluDisk(qaudricParam, d, d * 1.05, 36, 1);

  glTranslatef(0, 0, -0.1); // Schraube vor Nabe
  glColor3f(0.0, 0.0, 0.0);
  gluDisk(qaudricParam, 0.0, d / 10, 6, 1);
  glPopMatrix;
end;

procedure TForm1.Pleuel(d, l: single);
var
  d2: single;
begin
  d2 := d / 2;
  glPushMatrix;
  gluQuadricDrawStyle(qaudricParam, GLU_FILL);

  glBegin(GL_QUADS);
  glColor3f(1, 0.3, 0.3);
  glVertex3f(d2, -d2, 0);
  glVertex3f(l - d2, -d2, 0);
  glVertex3f(l - d2, d2, 0);
  glVertex3f(d2, d2, 0);
  glEnd();

  glTranslatef(0, 0, -0.1);
  glColor3f(1, 0.0, 0.0);
  gluDisk(qaudricParam, d / 2, d, 36, 1);
  glTranslatef(l, 0.0, 0.0);
  gluDisk(qaudricParam, d / 2, d, 36, 1);

  glPopMatrix;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
  OpenGLControl1.Repaint;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  InitOpenGL;
  OpenGLControl1.MakeCurrent;
  ReadExtensions;
  ReadImplementationProperties;
  qaudricParam := @gluNewQuadric;
  speed := 3.01;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  speed *= 1.1;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  speed /= 1.1;
end;

procedure TForm1.OpenGLControl1Paint(Sender: TObject);
const
  radD = 0.5;
  l = 1.5;
var
  p, zx, zy: single;
begin
  glClearColor(0.4, 0.2, 0.3, 1.0);
  glClear(GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT);
  glEnable(GL_DEPTH_TEST);

  glMatrixMode(GL_MODELVIEW);
  glLoadIdentity();

  glScalef(1.5, 1.5, 1.5);
  glTranslatef(-1.0, 0.0, 0.0);

  winkel += speed;
  if winkel > 360 then begin
    winkel -= 360;
  end;
  Rad(radD, 15, winkel);

  glPushMatrix;
  glTranslatef(0, 0, -0.3);
  zx := cos(winkel / 180 * Pi) * radD / 2;
  zy := sin(winkel / 180 * Pi) * radD / 2;

  glTranslatef(zx, zy, 0);

  glRotatef(arcsin(-zy / l) / Pi * 180, 0.0, 0.0, 1.0);
  //  glRotatef(arccos(-zx / l) / Pi * 180, 0.0, 0.0, 1.0); // senkrecht
  Pleuel(radD / 10, l);
  glPopMatrix;

  glPushMatrix;
  p := sqrt(sqr(l) - sqr(zy)) + zx;
  glTranslatef(p, 0.0, 0.0);
  Pleuel(radD / 10, l / 2);
  glPopMatrix;

  OpenGLControl1.SwapBuffers;
end;

procedure TForm1.OpenGLControl1Resize(Sender: TObject);
begin
  with OpenGLControl1 do begin
    glViewport(0, 0, Width, Height);
    glMatrixMode(GL_PROJECTION);
    glLoadIdentity();
    glScalef(Height / Width, 1.0, 1.0);
  end;
end;


initialization

  {$I unit1.lrs}

end.
